var PushBusiness = require("../../src/business/push");
var InitBusiness = require("../../src/business/init");
var EnvBusiness = require("../../src/business/environment");
var TestObjects = require("../testObjects");
var fs = require("fs");

describe("Push Color Mapping Business Suite", function() {

    beforeEach(()=>{
        pushBusiness = new PushBusiness();
        initBusiness = new InitBusiness();

        envBusiness =  new EnvBusiness();
        envBusiness.add("prod", "http://localhost:8080/insight");
    });

    afterEach(()=>{
        var files = fs.readdirSync('.').filter((file) => {
            return file.endsWith(".kw.yml");
        });
        files.map(fs.unlinkSync);
    });
    

    it("should push color mapping option", function(){
        initBusiness.init("CH_COLOR_MAP", TestObjects.CH_COLOR_MAP);

        spyOn(pushBusiness.api, '_doPost');

        pushBusiness.push("prod");

        expect(pushBusiness.api._doPost.calls.argsFor(0)[1]).toEqual({
            "charts": [{
                "chartType": "bar", 
                "code": "CH_COLOR_MAP", 
                "dataset": "DS_1", 
                "name": "Titulo",
                "dimensions": [
                    {   
                        "mappedColumns": [{
                            "alias": ["COL_1"],
                             "name": ["COL_1"]
                            }],
                            "name": "x"
                    }, {
                        "mappedColumns": [{
                            "alias": ["COL_2"], 
                            "name": ["COL_2"]
                        }], 
                        "name": "y"
                    }],
                "options": {
                    "colors": {
                        "RJ": "green",
                        "SP": "red"
                    }
                }
            }]  
        });         
    });

});