var PushBusiness = require("../../src/business/push");
var InitBusiness = require("../../src/business/init");
var EnvBusiness = require("../../src/business/environment");
var TestObjects = require("../testObjects");
var fs = require("fs");

describe("Push Color Mapping Business Suite", function() {

    beforeEach(()=>{
        pushBusiness = new PushBusiness();
        initBusiness = new InitBusiness();

        envBusiness =  new EnvBusiness();
        envBusiness.add("prod", "http://localhost:8080/insight");
    });

    afterEach(()=>{
        var files = fs.readdirSync('.').filter((file) => {
            return file.endsWith(".kw.yml");
        });
        files.map(fs.unlinkSync);
    });
    

    it("should push dashboard", function(){
        initBusiness.init("DASH_1", TestObjects.DASH_1);

        spyOn(pushBusiness.api, '_doPost');

        pushBusiness.push("prod");

        expect(pushBusiness.api._doPost.calls.argsFor(0)[1]).toEqual({
            "dashboards": [{
                "title": "DASHBOARD 1",
                "code": "DASH_1",
                "grid": [
                    {
                        "cols": [
                            {
                                "item": {
                                    "code": "CHART_1"
                                }
                            },
                            {
                                "item": {
                                    "code": "CHART_2"
                                }
                            }
                        ]
                    },
                    {
                        "cols": [
                            {
                                "item": {
                                    "code": "CHART_3"
                                }
                            }
                        ]
                    }
                ],
                "filters": [
                    {
                        "label": "COL_1",
                        "value": "COL_1"
                    },
                    {
                        "label": "COL_2",
                        "value": "COL_2"
                    }
                ]

            }]  
        });         
    });

});