var PushBusiness = require("../../src/business/push");
var InitBusiness = require("../../src/business/init");
var EnvBusiness = require("../../src/business/environment");
var TestObjects = require("../testObjects");
var fs = require("fs");

describe("Push Dimension Suite", function() {

    beforeEach(()=>{
        pushBusiness = new PushBusiness();
        initBusiness = new InitBusiness();

        envBusiness =  new EnvBusiness();
        envBusiness.add("prod", "http://localhost:8080/insight");
    });

    afterEach(()=>{
        var files = fs.readdirSync('.').filter((file) => {
            return file.endsWith(".kw.yml");
        });
        files.map(fs.unlinkSync);
    });
    

    it("should push dimensions with colunas mapped ", function(){
        initBusiness.init("CH_DIMENSION_WITH_COLUNAS_MAPPED", TestObjects.CH_DIMENSION_WITH_COLUNAS_MAPPED);

        spyOn(pushBusiness.api, '_doPost');

        pushBusiness.push("prod");

        expect(pushBusiness.api._doPost.calls.argsFor(0)[1]).toEqual({
            "charts": [{
                "chartType": "table",
                "code": "CH_DIMENSION_WITH_COLUNAS_MAPPED",
                "dataset": "DS_1",
                "name": "Titulo",
                "dimensions": [
                    {
                        "name": "Colunas",
                        "mappedColumns": [{
                            "name": "ID",
                            "alias": "ID",
                        },
                        {
                            "name": "COL1",
                            "alias": "COL1",
                        },
                        {
                            "name": "COL2",
                            "alias": "COL2",
                        }]
                    }
                ]
            }]  
        });         
    });

});