var PushBusiness = require("../../src/business/push");
var InitBusiness = require("../../src/business/init");
var EnvBusiness = require("../../src/business/environment");
var TestObjects = require("../testObjects");
var fs = require("fs");

describe("Push Link ColumnBusiness Suite", function() {

    beforeEach(()=>{
        pushBusiness = new PushBusiness();
        initBusiness = new InitBusiness();

        envBusiness =  new EnvBusiness();
        envBusiness.add("prod", "http://localhost:8080/insight");
    });

    afterEach(()=>{
        var files = fs.readdirSync('.').filter((file) => {
            return file.endsWith(".kw.yml");
        });
        files.map(fs.unlinkSync);
    });
    

    it("should push link column option - dynamic", function(){
        initBusiness.init("CH_LINK_COLUMN_DYNAMIC", TestObjects.CH_LINK_COLUMN_DYNAMIC);

        spyOn(pushBusiness.api, '_doPost');

        pushBusiness.push("prod");

        expect(pushBusiness.api._doPost.calls.argsFor(0)[1]).toEqual({
            "charts": [{
                "chartType": "table",
                "code": "CH_LINK_COLUMN_DYNAMIC",
                "dataset": "DS_1",
                "name": "Titulo",
                "dimensions": [
                    {
                        "name": "Colunas",
                        "mappedColumns": [{
                            "name": "ID",
                            "alias": "ID",
                        }]
                    }
                ],
                "options": {
                    "linkColumn": {
                        "name": "Itens Documento Fiscal",
                        "alias": "Ver",
                        "isDynamic": true,
                        "columName": "COL_1",
                        "url": "http://blablabla.com"
                    }
                }
            }]  
        });         
    });

    it("should push link column option", function(){
        initBusiness.init("CH_LINK_COLUMN", TestObjects.CH_LINK_COLUMN);

        spyOn(pushBusiness.api, '_doPost');

        pushBusiness.push("prod");

        expect(pushBusiness.api._doPost.calls.argsFor(0)[1]).toEqual({
            "charts": [{
                "chartType": "table",
                "code": "CH_LINK_COLUMN",
                "dataset": "DS_1",
                "name": "Titulo",
                "dimensions": [
                    {
                        "name": "Colunas",
                        "mappedColumns": [{
                            "name": "ID",
                            "alias": "ID",
                        }]
                    }
                ],
                "options": {
                    "linkColumn": {
                        "name": "",
                        "alias": "",
                        "isDynamic": false,
                        "columName": "COL_2",
                        "url": "http://blablabla2.com"
                    }
                }
            }]
        });
    });


});