var PushBusiness = require("../../src/business/push");
var InitBusiness = require("../../src/business/init");
var EnvBusiness = require("../../src/business/environment");
var TestObjects = require("../testObjects");
var fs = require("fs");

describe("Push Link ColumnBusiness Suite", function() {

    beforeEach(()=>{
        pushBusiness = new PushBusiness();
        initBusiness = new InitBusiness();

        envBusiness =  new EnvBusiness();
        envBusiness.add("prod", "http://localhost:8080/insight");
    });

    afterEach(()=>{
        var files = fs.readdirSync('.').filter((file) => {
            return file.endsWith(".kw.yml");
        });
        files.map(fs.unlinkSync);
    });
    

    it("should push conditional formatting option", function(){
        initBusiness.init("CH_LINK_COLUMN_DYNAMIC", TestObjects.CH_CONDITIONAL_FORMATTING);

        spyOn(pushBusiness.api, '_doPost');

        pushBusiness.push("prod");

        expect(pushBusiness.api._doPost.calls.argsFor(0)[1]).toEqual({
            "charts": [{
                "chartType": "table",
                "code": "CH_CONDITIONAL_FORMATTING",
                "dataset": "DS_1",
                "name": "Titulo",
                "dimensions": [
                    {
                        "name": "Colunas",
                        "mappedColumns": [{
                            "name": "ID",
                            "alias": "ID",
                        }]
                    }
                ],
                "options": {
                    "conditionalFormatting": [
                        {
                            "rule": "VALOR_ICMS > 1000",
                            "format": {
                                "fontColor": "red",
                                "bgColor": "grey",
                                "fontStyle": "italic"

                            }
                        },
                        {
                            "rule": "VALOR_ICMS < 1000",
                            "format": {
                                "fontColor": "blue",
                                "bgColor": "green",
                                "fontStyle": ["bold", "italic"]

                            }
                        }
                    ]
                }
            }]  
        });         
    });

});