var EnvCommand = require('../../src/commands/env');
var EnvBusiness = require('../../src/business/environment');
var fs = require("fs");

describe("Env Command Suite", function() {
  
    beforeEach(()=>{
        cmd = new EnvCommand();

        envBusiness = new EnvBusiness();
        envBusiness.add("stage", "http://stage.synchro.com.br/insight");
    });

    afterEach(()=>{
        var files = fs.readdirSync('.').filter((file) => {
            return file.endsWith(".kw.yml");
        });
        files.map(fs.unlinkSync);
    });


    it("add new Environment", function() {
        spyOn(cmd.console, "prompt").and.returnValue({
            then: function(_fn){
                _fn({url: "http://localhost:8080/insight"})
            }
        });

        cmd.run({add: "local"});

        expect(envBusiness.get("local")).not.toBeUndefined();
    });


    it("delete Environment", function() {
        cmd.run({delete: "stage"});
        expect(envBusiness.get("stage")).toBeUndefined();
    });   


    it("list Environments", function() {
        spyOn(cmd.console, "logSuccess");
        
        cmd.run({list: true});

        expect(cmd.console.logSuccess.calls.argsFor(0)[0]).toEqual('stage -> http://stage.synchro.com.br/insight');
    }); 

});