module.exports.DS_1 = {
    datasources: {
        DS_1: {
        type: "jdbc",
        url: "foo@localhost:5432/db",
        user: "foo",
        password: "bar",
        dialect: "postgres"
        }
    }
}

module.exports.DSET_1 = {
datasets: {
        DSET_1: {
            datasource: "DS_1",
            replica: true,
            query: "select * from users",
            name: "Datasource 1",
            description: "Datasource 1",
            columns: {
                ID: ["number(19,2)", "Identificador"],
                NAME: ["text(255)", "Nome"],
                BIRTHDATE: ["date", "Data de Nascimento"],
                SCORE: ["number", "Pontuacao"],
                STATEMENT: ["text", "Declaracao"]
            }
        }
    }
}


module.exports.CH_AGGR = {
    charts: {
        CH_AGGR: {
            data: {
                dataset: "DS_1",
                mapping: {
                    x: ["COL_1"],
                    y: ["COL_2"]
                }
            },
            options: {
                type: "bar",
                title: "Titulo",
                aggregation: {
                    COL_1: "sum"
                }
            }
        }
    }
}

module.exports.CH_COLOR_MAP = {
    charts: {
        CH_COLOR_MAP: {
            data: {
                dataset: "DS_1",
                mapping: {
                    x: ["COL_1"],
                    y: ["COL_2"]
                }
            },
            options: {
                type: "bar",
                title: "Titulo",
                colorMapping: {
                    SP: "red",
                    RJ: "green"
                }
            }
        }
    }
}


module.exports.CH_FORMATTER = {
    charts: {
        CH_FORMATTER: {
            data: {
                dataset: "DS_1",
                mapping: {
                    x: ["COL_1"],
                    y: ["COL_2"]
                }
            },
            options: {
                type: "bar",
                title: "Titulo",
                format: {
                    COL_1: "date",
                    COL_2: "text"
                }
            }
        }
    }
}

module.exports.CH_DATA_RESTRICTIONS = {
    charts: {
        CH_DATA_RESTRICTIONS: {
            data: {
                dataset: "DS_1",
                mapping: {
                    x: ["COL_1"],
                    y: ["COL_2"]
                },
                restrictions: {
                    COL_1: {
                        eq: ["SP", "RJ"],
                        ne: "ES"
                    },
                    COL_2: {
                        gt: 10,
                        lt: 20
                    }
                }
            },
            options: {
                type: "bar",
                title: "Titulo"
            }
        }
    }
}

module.exports.CH_LINK_COLUMN_DYNAMIC = {
    charts:{
        CH_LINK_COLUMN_DYNAMIC: {
            data: {
                dataset: "DS_1",
                mapping: {
                    Colunas: 'ID'
                }
            },
            options: {
                type: "table",
                title: "Titulo",
                link: {
                    columnLabel: "Itens Documento Fiscal",
                    label: "Ver",
                    url: "http://blablabla.com",
                    queryString: "COL_1"
                }
            }
        }
    }
}

module.exports.CH_DIMENSION_WITH_COLUNAS_MAPPED = {
    charts:{
        CH_DIMENSION_WITH_COLUNAS_MAPPED: {
            data: {
                dataset: "DS_1",
                mapping: {
                    Colunas: ["ID", "COL1", "COL2"]
                }
            },
            options: {
                type: "table",
                title: "Titulo",
            }
        }
    }
}

module.exports.CH_LINK_COLUMN = {
    charts:{
        CH_LINK_COLUMN: {
            data: {
                dataset: "DS_1",
                mapping: {
                    Colunas: "ID"
                }
            },
            options: {
                type: "table",
                title: "Titulo",
                link: {
                    columName: "COL_2",
                    url: "http://blablabla2.com"
                }
            }
        }
    }
}

module.exports.DASH_1 = {
    dashboards: {
        DASH_1: {
            title: "DASHBOARD 1",
            grid: [["CHART_1", "CHART_2"],["CHART_3"]],
            filters: ["COL_1", "COL_2"]
        }
    }
}


module.exports.CH_CONDITIONAL_FORMATTING = {
    charts:{
        CH_CONDITIONAL_FORMATTING: {
            data: {
                dataset: "DS_1",
                mapping: {
                    Colunas: "ID"
                }
            },
            options: {
                type: "table",
                title: "Titulo",
                conditionalFormatting: [
                    {
                        rule: "VALOR_ICMS > 1000",
                        format: {
                            "fontColor": "red",
                            "bgColor": "grey",
                            "fontStyle": "italic"

                        }
                    },
                    {
                        rule: "VALOR_ICMS < 1000",
                        format: {
                            "fontColor": "blue",
                            "bgColor": "green",
                            "fontStyle": ["bold", "italic"]

                        }
                    }
                ]
            }
        }
    }
}

describe("", function(){
    it("", function(){

    });
});