const fs = require("fs");
const yaml = require('js-yaml');
const _ = require("lodash");


class BaseBusiness {


    dump(prefix, object){
        var content = yaml.safeDump(object);
        fs.writeFileSync(prefix + '.kw.yml', content);
        return content;
    }

    unlink(prefix){
        return fs.unlinkSync(prefix + '.kw.yml');
    }

    load(prefix){
        var yamlObject = undefined;

        var fileName = prefix.endsWith(".kw.yml") ? prefix : prefix + '.kw.yml';

        if(fs.existsSync(fileName)) {
            var fileContents = fs.readFileSync(fileName, 'utf8');
            yamlObject = yaml.safeLoad(fileContents);
        }

        return yamlObject;
    }

    loadAll(){
        var files = fs.readdirSync('.');
        files  = _.filter(files, (file) => {
            return file.endsWith(".kw.yml") && file != 'env.kw.yml';
        });
        
        var objs = _.map(files, this.load);
        return objs;
    }

    

}

module.exports = BaseBusiness;