const BaseBusiness = require("./base");
const EnvBusiness = require("./environment");
const _ = require('lodash');
const KowalskiAPI = require('./api');

class PushBusiness extends BaseBusiness {
    
    constructor(){
        super();
        this.envBusiness = new EnvBusiness();
        this.api = new KowalskiAPI();
    }

    push(env){
        let environmentURL = this.envBusiness.get(env);

        if(!environmentURL){
            throw "Environment not found";
        }
        
        return this.api.post(environmentURL, this.loadAll());
    }

}

module.exports = PushBusiness;