var chalk = require('chalk');
var co = require('co');
var prompt = require('co-prompt');
var _padEnd = require('lodash/padEnd');


class Console{

    prompt(_vars){
        return co.wrap(function* () {
            var params = {};

            for(var x=0; x<_vars.length; x++){
                var v = _vars[x];
                params[v] = yield prompt(chalk.bold.yellow(v + ": "));
            }

            return yield params;
        })();
    }    

    log(msg){
        console.log(msg);
    }

    logSuccess(msg){
        if(msg) {
            console.log(chalk.bold.blue(msg));
        }
    }

    logErrorBanner(){
        console.log(chalk.white.bgRed.bold(_padEnd(' ERROR!', 80)));
    }

    logError(msg){
        if(msg) {
            console.log(chalk.bold.red(msg));
        }
    }

    logDim(msg){
        if(msg) {
            console.log(chalk.dim.white(msg));
        }
    }

    exit(code){
        process.exit(code);
    }

}

module.exports = Console;