"use strict";

var EnvBusiness = require('../business/environment');
var Console = require('./console');
var _each = require('lodash/each');

class EnvCommand {

    constructor(){
        this.envBusiness = new EnvBusiness();
        this.console = new Console();
    }

    run(options){
        if(options.add) {
            return this._add(options.add);
        } else if(options.delete) {
            return this._delete(options.delete);
        } else if(options.list) {
            return this._list();
        }
    }

    _add(name){
        return new Promise((resolve) => {
            this.console.prompt(["url"]).then(params => {
                this.envBusiness.add(name, params.url);
                resolve("Environment successfully added");
            });
        });
    }

    _delete(name){
        return new Promise((resolve) => {
            this.envBusiness.remove(name);
            resolve("Environment successfully deleted");
        });
    }

    _list(){
        return new Promise((resolve) => {
            _each(this.envBusiness.findAll(), (value, key) => {
                this.console.logSuccess(`${key} -> ${value}`);
            });

            resolve();
        });
    }
}

module.exports = EnvCommand;