var Console = require('./console');
var InitBusiness = require('../business/init.js');
var _invoke = require('lodash/invoke');

class InitCommand {

    constructor(){
        this.console = new Console();
        this.initBusiness = new InitBusiness();
    }

    run(type) {
        switch(type){
            case 'datasource':
                return this._init(['codigo', 'tipo'], 'initDatasource');
                break;
            case 'dataset':
                return this._init(['codigo', 'datasource', 'name'], 'initDataset')
                break;            
            case 'chart':
                return this._init(['tipo', 'codigo', 'titulo', 'dataset'], 'initChart')
                break;
            case 'report':
                return this._init(['codigo', 'titulo'], 'initReport');
                break;
            case 'dashboard':
                return this._init(['codigo', 'titulo'], 'initDashboard');
                break;
            default:
                throw `Não foi possível inicializar o objeto [${type}]: Tipo inválido`;
        }
    }

    _init(attributes, initFnName){
        return new Promise((resolve) => {
            this.console.prompt(attributes).then(params => {
                let ymlContent = _invoke(this.initBusiness, initFnName, params.codigo, params);

                this.console.log('\n------\n');
                this.console.logDim(ymlContent);
                this.console.logSuccess("Objeto criado com sucesso \n");

                resolve();
            });
        });
    }

}

module.exports = InitCommand;
