var PushBusiness = require("../business/push");
var Console = require('./console');

var _has = require('lodash/has');

class PushCommand {

    constructor(){
        this.pushBusiness = new PushBusiness();
        this.console = new Console();
    }

    run(envName){
        return new Promise((resolve, reject) => {

            this.pushBusiness.push(envName)
            .then((response) => {
                resolve([
                    `${response.data.objects} objetos enviados com sucesso!`
                ]);
            })
            .catch((error) => {
                if(_has(error, 'message') && _has(error, 'response')){
                    reject(`${error.message} \n ${error.response.data.message}`);
                } else {
                    reject(error);
                }
            });
            
        });        
    }

}


module.exports = PushCommand;